class Nose{// extends FacialFeature{
 
  //Dependent Values
  float hWidth, hHeight;
  Eye e;
  
  //Dynamic Values
  float nHeight, nWidth, nYOffset;
  float nYOffsetFactor; //factors the scale of the Y offset of the nose
  float sizeFactor;
  
  
  
  color strokeColor, fillColor;

  Nose(Head h, Eye e, color strokeColor, color fillColor, float sizeFactor){
    hWidth = h.getWidth();
    hHeight = h.getHeight();
    
    this.e = e;
    this.strokeColor = strokeColor;
    this.fillColor = fillColor;
    this.sizeFactor = sizeFactor;
  }
  
  void generateValues(){
   //NOSE
   nYOffsetFactor = (.1);  
   
   float possiblePercentOfHead = random(0,0.7);
  
   nHeight = random(2,hHeight*possiblePercentOfHead);//20;
   nWidth = random(2,hWidth*possiblePercentOfHead);//25;
   nYOffset = random(-1*hHeight*nYOffsetFactor,hHeight*nYOffsetFactor);
  }
  
   String toString(){
    return nHeight+","+nWidth+","+nYOffset;
  }
  
  void draw(){
      stroke(strokeColor);
      noFill();
    
      //nHeight, nWidth, nY;
      float x1,x2,x3,y1,y2,y3;
      x1 = hWidth/2 - nWidth/2; //bot left
      y1 = hHeight/2 + nHeight/2 + nYOffset;
      
      x2 = hWidth/2 + nWidth/2; //bot right
      y2 = hHeight/2 + nHeight/2 + nYOffset;
      
      x3 = hWidth/2; //top mid
      y3 = hHeight/2 - nHeight/2+ nYOffset;
      y3 = y3>e.getBotY() ? e.getBotY() : y3; //if the top mid is higher than the eyes, make it no higher than the eyes
      
      fill(255);
      triangle(x1,y1,x2,y2,x3,y3);
  }
  
  float getBottomY(){
     return hHeight/2 + nHeight/2 + nYOffset; 
  }
  
  float getHeight(){
     return nHeight; 
  }
}
