import processing.core.*; 
import processing.xml.*; 

import java.applet.*; 
import java.awt.*; 
import java.awt.image.*; 
import java.awt.event.*; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class Chernoff_02_normalFaceToJavascript extends PApplet {

Face f;
AI ai = new AI();
int containerSize = 200;
PFont font;



public void setup(){
 size(400,400); 
 background(150);
 smooth();
 makeFaces();
 
 font = createFont("Helvetica", 24);
 makeResetButton();
}

public void draw(){
  makeResetButton();
  f.drawFace();
}

public void makeFaces(){
   f = new Face((width/2),(height/2), containerSize);
   f.randomizeFace();
   f.drawFace();
}
/*
void mousePressed()
{
  boolean t = false;
  background(150);
  for (int i = 0; i < faces.size(); i++){
     Face f = (Face)faces.get(i);
     boolean clicked = f.isClicked(mouseX,mouseY,containerSize); 
     
     if (clicked){
       f.drawFace();
       //add this face to the AI
       t = true;
       ai.inputSelectedFeatures(f.getFaceStuff());
       //f.printFace();
       float rand = random(200, 99999);
       saveToJPG("Face"+rand+".jpg", f.getX()-(containerSize/2), f.getY()-(containerSize/2), containerSize);
       println(f.getX() + "/" + f.getY());
     }
  }
  
  if (!t){
    makeFaces();
  }
}
*/
/*
void mousePressed(){
 background(150);
 makeFaces(); 
 f.toString();
 makeResetButton();
}
*/

public String jsGetFace(){
  return f.toString();
}

public void jsFaceSuccess(boolean success){
  resetDisplay();
}

public void clearAll(){
  background(150);
}

public void resetDisplay(){
   background(150);
   f = null;
   makeFaces(); 
   makeResetButton();
}

public boolean overReset(){
 return mouseX > 5 && mouseX < 130 && mouseY > height-45 && mouseY <height-5;
}

public void mouseReleased(){
   if (overReset()){
     resetDisplay();
     f.toString(); //for debug
   } 
}

public void makeResetButton(){
 if (overReset()){
   fill(152,228,255);
   if (mousePressed){
      fill(107,161,180);
   }
 } else{
   fill(255);
 }
  
  stroke(0);
  rect(5, height-45, 130, 40);
  
  fill(0);
  textFont(font, 24); 
  text("Reset Face", 9, height-18);
}
static class AI{
  /*
  1. Preference:
    e.g. nHeight = random(2,30);
    give nHeight a Preference of 4. this means that it wants to be 4
    
    
  2. Range & Preference:
    e.g. nHeight = random(2,30);
    give it a range
    give it a preference.
    
    if preference is 12, and range is 8, then the preferred state will be
    random(8,16); --> 12 is directly in the middle
    
    
  3. Increase probability of a range
    Instead of totally random, make it a normal distribution, where the preferred value
      is more likely to occur.
      
  4. Weights
    When someone selects a face, (an attribute is selected at random).
    The attribute is then given more weight, such that it becomes more likely to occur.
    Perhaps the value is actually a normal distribution in of itself.
    */
    
  ArrayList headVals; //ArrayList of float

  AI(){
    headVals = new ArrayList();
  }

  public void inputSelectedFeatures(ArrayList faceStuff){
    //float[] thisHead = {head.getWidth(), head.getHeight()};
    //headVals.add(thisHead);

    //0. head; 1. eyes; 2. eyeBrows; 3. pupils; 4. nose; 5. mouth
    
    println(headVals);
  }
}
class Eye{// extends FacialFeature{
  //Dependent Values
  float hWidth;
  float hHeight;
  
  //random values
  float eHeight, eWidth;
  //Dynamic Values
  float eLeftX, eRightX, eY; //size
  float eSpace; //spacing between eyes
  
  int strokeColor, fillColor;
  
  Eye(Head h, int strokeColor, int fillColor, float sizeFactor){
    hWidth = h.getWidth();
    hHeight = h.getHeight();
    
    this.strokeColor = strokeColor;
    this.fillColor = fillColor;
  }
  
  public void generateValues(){
   //Dynamic Values
   eHeight = random(5,25);//15
   eWidth = random(5,25);//15
   eSpace = hWidth/3;
   eLeftX = (hWidth - eSpace)/2;
   eRightX = eLeftX+eSpace;
   eY = hHeight*(.25f);
  }  
  
  public String toString(){
   return eHeight+","+eWidth;
  }
  
  public void draw(){
    stroke(strokeColor);
    fill(fillColor);
    
    //draw left eye
    ellipseMode(CENTER);
    ellipse(eLeftX, eY, eHeight, eWidth);
    //draw right eye
    ellipse(eRightX, eY, eHeight, eWidth);
  }

  public float getEyeY(){
     return eY; 
  }
  
  public float getBotY(){
     return eY +eHeight/2; 
  }
  
  public float getEyeHeight(){
    return eHeight;
  }
  
  public float getRightX(){
   return eRightX; 
  }
  
  public float getLeftX(){
   return eLeftX; 
  }
}
class EyeBrows{// extends FacialFeature{
  
  //Dependent Values
  float eyeY, eyeHeight, eyeLeftX, eyeRightX;
  float eBrowY;
  float sizeFactor;
  
  //Dynamic Values
  float eBrowLength, eBrowMid, eBrowStartY, eBrowMidY, eBrowEndY;
  
  int strokeColor, fillColor;
  
  //External Values
  Eye e;
  
  EyeBrows(Eye eye, int strokeColor, int fillColor, float sizeFactor){
    e = eye;
    
    this.strokeColor = strokeColor;
    this.fillColor = fillColor;
    this.sizeFactor = sizeFactor;
  }
  
  //EYEBROWS
  public void generateValues(){
   //Dependent values
   eyeY = e.getEyeY();
   eyeHeight = e.getEyeHeight();
   eyeLeftX = e.getLeftX();
   eyeRightX = e.getRightX();
   eBrowY = e.getEyeY() - (e.getEyeHeight()/2); //eY - eHeight/2;
   
   //Dynamic Values
   eBrowLength = random(10,30);//20;
   eBrowMid = random(0,eBrowLength);//17; //zero to eBrowLength
   eBrowStartY = random(-5,5);//0;
   eBrowMidY = random(-7,7);//7;
   eBrowEndY = random(-5,5);//2; 
  }
  
  public String toString(){
    return eBrowLength+","+eBrowMid+","+eBrowStartY+","+eBrowMidY+","+eBrowEndY;
  }
  
   public void draw(){
     
     stroke(strokeColor);
     noFill();
     
     float LX1 = eyeLeftX-(eBrowLength/2);
     float LY1 = eBrowY + eBrowStartY;
     float LX2 = LX1+eBrowMid;
     float LY2 = eBrowY + eBrowMidY;
     float LX3 = LX1+eBrowLength;
     float LY3 = eBrowY+eBrowEndY;
     drawBrowHelper(LX1, LY1, LX2, LY2, LX3, LY3);
     
     float RX1 = eyeRightX+(eBrowLength/2); //starts at the far right
     float RY1 = eBrowY + eBrowStartY;
     float RX2 = RX1-eBrowMid;
     float RY2 = eBrowY + eBrowMidY;
     float RX3 = RX1-eBrowLength;
     float RY3 = eBrowY+eBrowEndY;
     drawBrowHelper(RX1, RY1, RX2, RY2, RX3, RY3);
  } 
  
  public void drawBrowHelper(float x1,float y1,float x2,float y2,float x3,float y3){
    line(x1, y1, x2, y2);
    line(x2, y2, x3, y3);
  }
}
class Face{
  /*
  * Parameters that adjust the appearance of the Face.
  * Code loosely Adapted from John Wiseman
  */
  /* Etc */
  int strokeColor, fillColor;
  
  float maxSize, sizeFactor;
  float x_origin, y_origin;
  
  Head head;
  Eye eyes;
  EyeBrows eyeBrows;
  Pupil pupils;
  Nose nose;
  Mouth mouth;
  
  /* constructor */
  Face(int x, int y, int maxSize){
    x_origin = x;
    y_origin = y;
    this.maxSize = maxSize;
    //create a factor so we can resize. divide by 100 because the face was originally 
    // optimized for a size of 100
    sizeFactor = maxSize/100; 
    
    randomizeFace(); // just colors now
    
     head = new Head(strokeColor, fillColor, maxSize);
     head.generateValues();
     
     eyes = new Eye(head, strokeColor, fillColor, sizeFactor);//, sizeFactor);
     eyes.generateValues();
     
     eyeBrows = new EyeBrows(eyes, strokeColor, fillColor, sizeFactor);
     eyeBrows.generateValues();
     
     pupils = new Pupil(eyes, sizeFactor);
     pupils.generateValues();
     
     nose = new Nose(head, eyes, strokeColor, fillColor, sizeFactor);
     nose.generateValues();
     
     mouth = new Mouth(head, nose, strokeColor, fillColor, sizeFactor);
     mouth.generateValues();
  }

  public int getX(){
   return (int)x_origin; 
  }
  
  public int getY(){
   return (int)y_origin; 
  }
  
  public void drawFace(){
   pushMatrix();
   translate(x_origin, y_origin);
     head.draw();
   pushMatrix();
   translate(-head.getWidth()/2, -head.getHeight()/2); //center the features on the head
     eyes.draw();
     pupils.draw();
     eyeBrows.draw();
     nose.draw();
     mouth.draw();
   popMatrix();
   popMatrix();
  }
 
   public void randomizeFace(){
     strokeColor = color(random(0,255), random(0,255), random(0,255));
     fillColor = color(255);
   }

  
  public ArrayList getFaceStuff(){
    ArrayList stuff = new ArrayList();
    stuff.add(head); 
    stuff.add(eyes); 
    stuff.add(eyeBrows); 
    stuff.add(pupils); 
    stuff.add(nose);
    stuff.add(mouth);
   /*
    ArrayList stuff = new ArrayList();
    //HEAD
    stuff.add(hWidth); stuff.add(hHeight);
    //EYES
    stuff.add(eLeftX); stuff.add(eRightX); stuff.add(eY);
    stuff.add(eSize); stuff.add(eHeight); stuff.add(eWidth);
    stuff.add(eSpace); stuff.add(eSlope);
    //BROWS
    stuff.add(eBrowY); stuff.add(eBrowLength); stuff.add(eBrowMid);
    stuff.add(eBrowStartY); stuff.add(eBrowMidY); stuff.add(eBrowEndY);
    //NOSE
    stuff.add(nHeight); stuff.add(nWidth);  stuff.add(nYOffset);
    //MOUTH
    stuff.add(mouth1); stuff.add(mouth2); stuff.add(mouth3); stuff.add(mY);
    //COLOR
    stuff.add(strokeColor); stuff.add(fillColor);
    //PUPIL
    stuff.add(ePupilSize); stuff.add(pColor);
    return stuff;
  */
  return stuff;
  }
  
  public void printFace(){
    ArrayList a = getFaceStuff();
  }
  
  public Face getFace(){
     return this; 
  }
  
    public boolean isClicked(int x, int y, int containerSize){
      
      float len = (x_origin+containerSize)-x_origin;
      float openSpace = (len - head.getWidth())/2;
      float yLen = (y_origin+containerSize)-y_origin;
      float yOpen = (yLen - head.getHeight())/2;
      
  //    //DEBUG Hit Space
  //    fill(0);
  //    stroke(120);
  //    rect(x_origin-(containerSize/2),y_origin-(containerSize/2),
  //    x_origin+(containerSize)-(containerSize/2),y_origin+(containerSize)-(containerSize/2));
  //    fill(255,127,127, 20);
  //    stroke(255);
  //    rect(x_origin+openSpace-(containerSize/2),y_origin+yOpen-(containerSize/2),
  //    hWidth,hHeight);
      
      if (x_origin+openSpace-(containerSize/2) < x && x_origin+openSpace-(containerSize/2)+head.getWidth() > x
      && y_origin+yOpen-(containerSize/2) < y && y_origin+yOpen-(containerSize/2)+head.getHeight() > y){
        return true;
      }
      return false;
    }
    
    
  public String toString(){
    String s = head.toString() + ":" + eyes.toString() + ":" + eyeBrows.toString() + ":" + 
      pupils.toString() + ":" + nose.toString() + ":" + mouth.toString();
      
    println("String: " + s);
    return s;
  }
}
class Head{// extends FacialFeature{
  //Dependent Values
  float maxSize;
  
  //Dynamic Values
  float hHeight;
  float hBotWidth, hMidWidth, hTopWidth;
  float topx,topy,botx,boty;
  
  int strokeColor, fillColor;
  
  int drawMode = 0;
  int CIRCLE = 0;
  int CURVE = 1;
  
  Head(int strokeColor, int fillColor, float maxSize){
    this.strokeColor = strokeColor;
    this.fillColor = fillColor;
    this.maxSize = maxSize;
    
    drawMode = PApplet.parseInt(random(0,2));
    //drawMode = 1;
  }
  
  public void draw(){
    stroke(strokeColor);
    fill(fillColor);
    
    if (drawMode == CIRCLE){
      ellipse(0, 0, hTopWidth, hHeight);
    } else {

      float midX = 0;
      float midY = 0;
      
      fill(255);
      beginShape();
      curveVertex(-botx, boty); //O
      curveVertex(-topx,- topy); //B
      curveVertex(topx, - topy); //R
      curveVertex(botx, + boty); //G
      curveVertex(-botx, + boty); //O
      curveVertex(-topx, -topy); //B
      curveVertex(topx,-topy); //R
      endShape(CLOSE);
      
      //DEBUG
     /* 
      rectMode(CENTER);
      fill(0,0,255);//B
      rect(-topx, -topy, 10,10);
      fill(255,00,00); //R
      rect(topx,-topy, 10,10);
      
      fill(255,127,00); //O
      rect(-botx, boty, 10,10);
      fill(00,255,00); //G
      rect(botx,  boty, 10,10);
      */
    }
  }
  
  public void generateValues(){
   //HEAD

   if (drawMode == CIRCLE){
      hTopWidth = random(40, maxSize);
      hBotWidth = hTopWidth;
      hMidWidth = hTopWidth;
      hHeight = random(40, maxSize);
    } else {
      topx = random(30, maxSize/2);
      topy = random(50, maxSize/2);
      botx = random(30, maxSize/2);
      boty = random(50, maxSize/2);
      
      float xDiff = abs(botx-topx)/2;
      //hWidth = topx>botx ? topx-xDiff : botx-xDiff;
      hTopWidth = topx*2;
      hMidWidth = topx>botx ? topx-xDiff : botx-xDiff;
      hBotWidth = botx*2;
      hHeight = topy+boty;
    }
    
   // println("Height: " + hHeight);
  }
  
   public String toString(){
    return hTopWidth+","+hMidWidth+","+hBotWidth+","+hHeight;
  }
  
 public float getTopWidth(){
  return hTopWidth; 
 }
 
 public float getWidth(){
  return hMidWidth; 
 }
 
 public float getBotWidth(){
  return hBotWidth;  
 }
 
 public float getHeight(){
  return hHeight; 
 }
  
}
class Mouth{// extends FacialFeature{
  
  //Dependent Values
  float hHeight, hWidth, hBotWidth, hTopWidth;
  float noseBottomY, noseHeight;
  float sizeFactor;
  
  //Dynamic Values
  float mouth1, mouth2, mouth3;
  float mY, mYOffset, mYOffsetFactor;
  
  int strokeColor, fillColor;
  
  Mouth(Head h, Nose n, int strokeColor, int fillColor, float sizeFactor){
    hHeight = h.getHeight();
    hWidth = h.getWidth();
    hBotWidth = h.getBotWidth();
    hTopWidth = h.getTopWidth();
    noseBottomY = n.getBottomY();
    noseHeight = n.getHeight();
    
    this.strokeColor = strokeColor;
    this.fillColor = fillColor;
    this.sizeFactor = sizeFactor;
  }
 
  public void generateValues(){
    mouth1 = random(-1,2); //height (distance from baseline), controls one lip
    mouth2 = random(0,hBotWidth/20); //width
    mouth3 = random(-2,2);
    
    mY = makeGoodY();
    //println("hHeight/mY :: 1/2/3: "+hHeight+"/"+mY+":: "+mouth1+" /"+mouth2+" /"+mouth3);
  }
  
   public String toString(){
    return mouth1+","+mouth2+","+mouth3+","+mY;
  }
  
  //make a good Y value that does not conflict with the nose
  public float makeGoodY(){
    mYOffsetFactor = (.1f);  
    mYOffset = random(-hHeight*mYOffsetFactor, hHeight*mYOffsetFactor); 
    float mYHeightFactor;
    if (hTopWidth == hBotWidth){
      //a hack for circle heads
      if (mouth1<0 && mouth2<0){
        mYHeightFactor = .85f; 
      } else {
        mYHeightFactor = .8f;
      }
      
    } else { //for "nice" faces
      if (mouth1<0 && mouth2<0){
       //testY += abs(mouth1+mouth2)*10;//*random(0,3);
        mYHeightFactor = 1; 
      } else {
        mYHeightFactor = .9f;
      }
    } 
    //offset based on frown or smile
    float testY = hHeight*(mYHeightFactor)+mYOffset;
    
    int safetyCounter = 0;
    
    //if our Y value is in the nose, then try again
    while (testY < noseBottomY + (noseHeight/4) && safetyCounter < 30){ //noseHeight/10 to let the mouth be no more than 10% in the nose
      mYOffset = random(-1*hHeight*mYOffsetFactor, hHeight*mYOffsetFactor);
      testY = hHeight*(mYHeightFactor)+mYOffset;
      safetyCounter++;
    }
    
    if (testY < noseBottomY + (noseHeight/4)){
      println("fail!"); 
    }
    
    return testY;
  }
  
  public void draw(){
    stroke(strokeColor);
    noFill();
    
    float center = hWidth/2;
    double mouth_size = ((mouth2 - 0.5f) * 10);
    double x1 = center-10 - mouth_size;
    double y1 = mY;
    double x2 = center+10 + mouth_size;
    double y2 = mY;
    double x3 = ((x2 - x1) / 2) + x1;
    double y3 = ((mouth1 - 0.5f) * 10) + mY;
    
    drawLip(x1, y1, x2, y2, x3, y3);
    drawLip(x1, y1, x2, y2, x3, y3 + ((mouth3 / 2.0f) * 10));
  }
  
  public void drawLip(double x1, double y1, double x2, double y2, double x3, double y3){
      int i, new_x, new_y, last_x, last_y;

		// This is some nasty parabolic stuff.  It doesn't look that good because of the stupid
		// way we scale to non- 100x100 displays.
double denom =  (Math.pow(x1, 2) * (x2 - x3))
		+  (x1 * (Math.pow(x3, 2) - Math.pow(x2, 2)))
		+  (Math.pow(x2, 2) * x3)
		+ -(Math.pow(x3, 2) * x2);

		double a     = (   (y1 * (x2 - x3))
		+  (x1 * (y3 - y2))
		+  (y2 * x3)
		+ -(y3 * x2))
		/ denom;
					   
		double bb    = (   (Math.pow(x1, 2) * (y2 - y3))
		+  (y1 * (Math.pow(x3, 2) - Math.pow(x2, 2)))
		+  (Math.pow(x2, 2) * y3)
		+ -(Math.pow(x3, 2) * y2))
		/ denom;
					 
		double c     = (   (Math.pow(x1, 2) * ((x2 * y3) - (x3 * y2)))
		+  (x1 * ((Math.pow(x3, 2) * y2) - (Math.pow(x2, 2) * y3)))
		+  (y1 * ((Math.pow(x2, 2) * x3) - (Math.pow(x3, 2) * x2))))
		/ denom;
		
		for(i = (int)x1, last_x = (int)x1, last_y = (int)y1; i <= x2; i++) {
			new_x = i;
			new_y = (int)((a * Math.pow(i, 2)) + (bb * i) + c);
			line(last_x, last_y, new_x, new_y);
			last_x = new_x;
			last_y = new_y;
		}


  }
  
}
class Nose{// extends FacialFeature{
 
  //Dependent Values
  float hWidth, hHeight;
  Eye e;
  
  //Dynamic Values
  float nHeight, nWidth, nYOffset;
  float nYOffsetFactor; //factors the scale of the Y offset of the nose
  float sizeFactor;
  
  
  
  int strokeColor, fillColor;

  Nose(Head h, Eye e, int strokeColor, int fillColor, float sizeFactor){
    hWidth = h.getWidth();
    hHeight = h.getHeight();
    
    this.e = e;
    this.strokeColor = strokeColor;
    this.fillColor = fillColor;
    this.sizeFactor = sizeFactor;
  }
  
  public void generateValues(){
   //NOSE
   nYOffsetFactor = (.1f);  
   
   float possiblePercentOfHead = random(0,0.7f);
  
   nHeight = random(2,hHeight*possiblePercentOfHead);//20;
   nWidth = random(2,hWidth*possiblePercentOfHead);//25;
   nYOffset = random(-1*hHeight*nYOffsetFactor,hHeight*nYOffsetFactor);
  }
  
   public String toString(){
    return nHeight+","+nWidth+","+nYOffset;
  }
  
  public void draw(){
      stroke(strokeColor);
      noFill();
    
      //nHeight, nWidth, nY;
      float x1,x2,x3,y1,y2,y3;
      x1 = hWidth/2 - nWidth/2; //bot left
      y1 = hHeight/2 + nHeight/2 + nYOffset;
      
      x2 = hWidth/2 + nWidth/2; //bot right
      y2 = hHeight/2 + nHeight/2 + nYOffset;
      
      x3 = hWidth/2; //top mid
      y3 = hHeight/2 - nHeight/2+ nYOffset;
      y3 = y3>e.getBotY() ? e.getBotY() : y3; //if the top mid is higher than the eyes, make it no higher than the eyes
      
      fill(255);
      triangle(x1,y1,x2,y2,x3,y3);
  }
  
  public float getBottomY(){
     return hHeight/2 + nHeight/2 + nYOffset; 
  }
  
  public float getHeight(){
     return nHeight; 
  }
}
class Pupil{// extends FacialFeature{
  //Dependent Values
  float eLeftX, eRightX, eY;
  float sizeFactor;

  //Dynamic Values
  float ePupilSize, pColor;
 
  Pupil(Eye e, float sizeFactor){
    eLeftX = e.getLeftX();
    eRightX = e.getRightX();
    eY = e.getEyeY();
    this.sizeFactor = sizeFactor;
  } 
 
  public void draw(){
    ellipseMode(CENTER);
    noStroke();
    fill(pColor);
    
    ellipse(eLeftX, eY, ePupilSize, ePupilSize);
    ellipse(eRightX, eY, ePupilSize, ePupilSize);
  }
  
  public void generateValues(){
    ePupilSize = random(.5f,5);
    pColor = color(random(0,255), random(0,255), random(0,255));
  }
  
   public String toString(){
    return ePupilSize+","+pColor;
  }
  
}

  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#ECE9D8", "Chernoff_02_normalFaceToJavascript" });
  }
}
