class Face{
  /*
  * Parameters that adjust the appearance of the Face.
  * Code loosely Adapted from John Wiseman
  */
  /* Etc */
  color strokeColor, fillColor;
  
  float maxSize, sizeFactor;
  float x_origin, y_origin;
  
  Head head;
  Eye eyes;
  EyeBrows eyeBrows;
  Pupil pupils;
  Nose nose;
  Mouth mouth;
  
  /* constructor */
  Face(int x, int y, int maxSize){
    x_origin = x;
    y_origin = y;
    this.maxSize = maxSize;
    //create a factor so we can resize. divide by 100 because the face was originally 
    // optimized for a size of 100
    sizeFactor = maxSize/100; 
    
    randomizeFace(); // just colors now
    
     head = new Head(strokeColor, fillColor, maxSize);
     head.generateValues();
     
     eyes = new Eye(head, strokeColor, fillColor, sizeFactor);//, sizeFactor);
     eyes.generateValues();
     
     eyeBrows = new EyeBrows(eyes, strokeColor, fillColor, sizeFactor);
     eyeBrows.generateValues();
     
     pupils = new Pupil(eyes, sizeFactor);
     pupils.generateValues();
     
     nose = new Nose(head, eyes, strokeColor, fillColor, sizeFactor);
     nose.generateValues();
     
     mouth = new Mouth(head, nose, strokeColor, fillColor, sizeFactor);
     mouth.generateValues();
  }

  int getX(){
   return (int)x_origin; 
  }
  
  int getY(){
   return (int)y_origin; 
  }
  
  void drawFace(){
   pushMatrix();
   translate(x_origin, y_origin);
     head.draw();
   pushMatrix();
   translate(-head.getWidth()/2, -head.getHeight()/2); //center the features on the head
     eyes.draw();
     pupils.draw();
     eyeBrows.draw();
     nose.draw();
     mouth.draw();
   popMatrix();
   popMatrix();
  }
 
   void randomizeFace(){
     strokeColor = color(random(0,255), random(0,255), random(0,255));
     fillColor = color(255);
   }

  
  ArrayList getFaceStuff(){
    ArrayList stuff = new ArrayList();
    stuff.add(head); 
    stuff.add(eyes); 
    stuff.add(eyeBrows); 
    stuff.add(pupils); 
    stuff.add(nose);
    stuff.add(mouth);
   /*
    ArrayList stuff = new ArrayList();
    //HEAD
    stuff.add(hWidth); stuff.add(hHeight);
    //EYES
    stuff.add(eLeftX); stuff.add(eRightX); stuff.add(eY);
    stuff.add(eSize); stuff.add(eHeight); stuff.add(eWidth);
    stuff.add(eSpace); stuff.add(eSlope);
    //BROWS
    stuff.add(eBrowY); stuff.add(eBrowLength); stuff.add(eBrowMid);
    stuff.add(eBrowStartY); stuff.add(eBrowMidY); stuff.add(eBrowEndY);
    //NOSE
    stuff.add(nHeight); stuff.add(nWidth);  stuff.add(nYOffset);
    //MOUTH
    stuff.add(mouth1); stuff.add(mouth2); stuff.add(mouth3); stuff.add(mY);
    //COLOR
    stuff.add(strokeColor); stuff.add(fillColor);
    //PUPIL
    stuff.add(ePupilSize); stuff.add(pColor);
    return stuff;
  */
  return stuff;
  }
  
  void printFace(){
    ArrayList a = getFaceStuff();
  }
  
  Face getFace(){
     return this; 
  }
  
    boolean isClicked(int x, int y, int containerSize){
      
      float len = (x_origin+containerSize)-x_origin;
      float openSpace = (len - head.getWidth())/2;
      float yLen = (y_origin+containerSize)-y_origin;
      float yOpen = (yLen - head.getHeight())/2;
      
  //    //DEBUG Hit Space
  //    fill(0);
  //    stroke(120);
  //    rect(x_origin-(containerSize/2),y_origin-(containerSize/2),
  //    x_origin+(containerSize)-(containerSize/2),y_origin+(containerSize)-(containerSize/2));
  //    fill(255,127,127, 20);
  //    stroke(255);
  //    rect(x_origin+openSpace-(containerSize/2),y_origin+yOpen-(containerSize/2),
  //    hWidth,hHeight);
      
      if (x_origin+openSpace-(containerSize/2) < x && x_origin+openSpace-(containerSize/2)+head.getWidth() > x
      && y_origin+yOpen-(containerSize/2) < y && y_origin+yOpen-(containerSize/2)+head.getHeight() > y){
        return true;
      }
      return false;
    }
    
    
  String toString(){
    String s = head.toString() + ":" + eyes.toString() + ":" + eyeBrows.toString() + ":" + 
      pupils.toString() + ":" + nose.toString() + ":" + mouth.toString();
      
    println("String: " + s);
    return s;
  }
}
