class Mouth{// extends FacialFeature{
  
  //Dependent Values
  float hHeight, hWidth, hBotWidth, hTopWidth;
  float noseBottomY, noseHeight;
  float sizeFactor;
  
  //Dynamic Values
  float mouth1, mouth2, mouth3;
  float mY, mYOffset, mYOffsetFactor;
  
  color strokeColor, fillColor;
  
  Mouth(Head h, Nose n, color strokeColor, color fillColor, float sizeFactor){
    hHeight = h.getHeight();
    hWidth = h.getWidth();
    hBotWidth = h.getBotWidth();
    hTopWidth = h.getTopWidth();
    noseBottomY = n.getBottomY();
    noseHeight = n.getHeight();
    
    this.strokeColor = strokeColor;
    this.fillColor = fillColor;
    this.sizeFactor = sizeFactor;
  }
 
  void generateValues(){
    mouth1 = random(-1,2); //height (distance from baseline), controls one lip
    mouth2 = random(0,hBotWidth/20); //width
    mouth3 = random(-2,2);
    
    mY = makeGoodY();
    //println("hHeight/mY :: 1/2/3: "+hHeight+"/"+mY+":: "+mouth1+" /"+mouth2+" /"+mouth3);
  }
  
   String toString(){
    return mouth1+","+mouth2+","+mouth3+","+mY;
  }
  
  //make a good Y value that does not conflict with the nose
  float makeGoodY(){
    mYOffsetFactor = (.1);  
    mYOffset = random(-hHeight*mYOffsetFactor, hHeight*mYOffsetFactor); 
    float mYHeightFactor;
    if (hTopWidth == hBotWidth){
      //a hack for circle heads
      if (mouth1<0 && mouth2<0){
        mYHeightFactor = .85; 
      } else {
        mYHeightFactor = .8;
      }
      
    } else { //for "nice" faces
      if (mouth1<0 && mouth2<0){
       //testY += abs(mouth1+mouth2)*10;//*random(0,3);
        mYHeightFactor = 1; 
      } else {
        mYHeightFactor = .9;
      }
    } 
    //offset based on frown or smile
    float testY = hHeight*(mYHeightFactor)+mYOffset;
    
    int safetyCounter = 0;
    
    //if our Y value is in the nose, then try again
    while (testY < noseBottomY + (noseHeight/4) && safetyCounter < 30){ //noseHeight/10 to let the mouth be no more than 10% in the nose
      mYOffset = random(-1*hHeight*mYOffsetFactor, hHeight*mYOffsetFactor);
      testY = hHeight*(mYHeightFactor)+mYOffset;
      safetyCounter++;
    }
    
    if (testY < noseBottomY + (noseHeight/4)){
      println("fail!"); 
    }
    
    return testY;
  }
  
  void draw(){
    stroke(strokeColor);
    noFill();
    
    float center = hWidth/2;
    double mouth_size = ((mouth2 - 0.5) * 10);
    double x1 = center-10 - mouth_size;
    double y1 = mY;
    double x2 = center+10 + mouth_size;
    double y2 = mY;
    double x3 = ((x2 - x1) / 2) + x1;
    double y3 = ((mouth1 - 0.5) * 10) + mY;
    
    drawLip(x1, y1, x2, y2, x3, y3);
    drawLip(x1, y1, x2, y2, x3, y3 + ((mouth3 / 2.0) * 10));
  }
  
  void drawLip(double x1, double y1, double x2, double y2, double x3, double y3){
      int i, new_x, new_y, last_x, last_y;

		// This is some nasty parabolic stuff.  It doesn't look that good because of the stupid
		// way we scale to non- 100x100 displays.
double denom =  (Math.pow(x1, 2) * (x2 - x3))
		+  (x1 * (Math.pow(x3, 2) - Math.pow(x2, 2)))
		+  (Math.pow(x2, 2) * x3)
		+ -(Math.pow(x3, 2) * x2);

		double a     = (   (y1 * (x2 - x3))
		+  (x1 * (y3 - y2))
		+  (y2 * x3)
		+ -(y3 * x2))
		/ denom;
					   
		double bb    = (   (Math.pow(x1, 2) * (y2 - y3))
		+  (y1 * (Math.pow(x3, 2) - Math.pow(x2, 2)))
		+  (Math.pow(x2, 2) * y3)
		+ -(Math.pow(x3, 2) * y2))
		/ denom;
					 
		double c     = (   (Math.pow(x1, 2) * ((x2 * y3) - (x3 * y2)))
		+  (x1 * ((Math.pow(x3, 2) * y2) - (Math.pow(x2, 2) * y3)))
		+  (y1 * ((Math.pow(x2, 2) * x3) - (Math.pow(x3, 2) * x2))))
		/ denom;
		
		for(i = (int)x1, last_x = (int)x1, last_y = (int)y1; i <= x2; i++) {
			new_x = i;
			new_y = (int)((a * Math.pow(i, 2)) + (bb * i) + c);
			line(last_x, last_y, new_x, new_y);
			last_x = new_x;
			last_y = new_y;
		}


  }
  
}
